#!/usr/local/bin/jperl5
use Extract;

&main();
exit(0);

sub main () {
   
    # setting
    my $obj = Extract->new->verbose->comb(1)->min_frq(0)->window(100000)->rate(0.01);
     $obj = &get_noun_frq($obj,@ARGV);	
    
    # start
    $obj->extract(@ARGV)->output(@ARGV);
;# ========================================================================
;# get_noun_frq -- Get noun frequency from input files.
;#                 The values of the hash are frequency of the noun.
;#
;# usage: $obj = $obj->get_noun_frq(@FILES);
;#        $obj = $obj->get_noun_frq($FILENAME);
;#
;# ========================================================================

    sub get_noun_frq ($;@){
	my $this = shift;     # object
	my $tagged = shift(@_);     # tagged source file
	my %frq;

	
	# ׸ȻפΤ
	open(TAGGED, $tagged) || die "$tagged : $!\n";
	
	while(<TAGGED>){
	    chomp;
	    # print $_, "\n";
	    my @words = split(/ /, $_);
	    
	    # @status ǤޤǤξȽ
	    # $status = 0   
	    #           1   ̾
	    #           2   ƻ
	    #           3   POS
	    #           4   of
	    #           5   CD
	    #           6   VBN
	    my @status = (0);
	    my @seg    = ();
	    
	    foreach(@words){
		# print 'stat : ', @status, "\n";
		if(/^[-%\&\$\*\#\w\^]\// || /^[\d]+\//){
		    _increase_frq(\%frq, \@status, @seg);
		    @seg    = ();
		    @status = (0);
		    next;
		}
		s/[A-Z\$]+$/WANA/ if /suusiki/;  # suusikiޤñʻѤ롣
		
		if(/NN[PS]?$/){
		    $_ = &_stemming($_) if /NNS$/;   # ʣñ֤롣
		    tr/^A-Z/a-z/ if (/NNS?$/ && /^[A-Z][a-z]/);   # Ƭʸʸˡ
		    unshift(@status, 1);
		    push(@seg, $_);
		}elsif(/JJ$/){
		    if($status[0] == 0 || $status[0] == 2 || $status[0] == 3 || $status[0] == 5){
			unshift(@status, 2);
			push(@seg, $_);
		    }else{
			&_increase_frq(\%frq, \@status, @seg);
			@seg    = ($_);
			@status = (2, 0);
		    }
		}elsif(/POS$/){
		    if($status[0] == 1){
			push(@seg, $_);
			unshift(@status, 3);
		    }else{
			&_increase_frq(\%frq, \@status, @seg);
			@seg    = ();
			@status = (0);
		    }
		}elsif(/FW$/){
		    &_increase_frq(\%frq, \@status, @seg) unless @seg == 0;
		    @status = (1, 0);
		    &_increase_frq(\%frq, \@status, ($_));
		    @seg    = ();
		    @status = (0);
		}elsif(/CD$/){
		    &_increase_frq(\%frq, \@status, @seg) unless @seg == 0;
		    @seg    = ($_);
		    @status = (5, 0);
		}elsif(/^of\/IN$/){
		    if($status[0] == 1){
			push(@seg, $_);
			unshift(@status, 4);
		    }else{
			&_increase_frq(\%frq, \@status, @seg) unless @seg == 0;
			@seg    = ();
			@status = (0);
		    }
		}elsif(/VBN$/){
		    &_increase_frq(\%frq, \@status, @seg) unless @seg == 0;
		    @seg    = ($_);
		    @status = (6, 0);
		}else{
		    unless(@seg == 0){
			&_increase_frq(\%frq, \@status, @seg);
			@seg    = ();
			@status = (0);
		    }
		}
	    }
	    &_increase_frq(\%frq, \@status, @seg);
	}
  
	$this->{'noun_frq'} = \%frq;
	print STDERR "done.\n"         if $this->{'env'}{'verbose'};
	print STDERR
            scalar keys %{$this->{'noun_frq'}}, 
            " nouns are candidates.\n" if $this->{'env'}{'verbose'};
        

	$this;
    
    }

;# ---------------------------------------------------------------------------
;#   _stemming  --  ʣñѤstemmer
;# 
;#   usage : _stemming(word);
;# ---------------------------------------------------------------------------

sub _stemming($;){
    local($_) = shift;
  
    if(/ies\// && $_ !~ /[ae]ies\//){
	s/ies\//y\//;
    }elsif(/es\// && $_ !~ /[aeo]es\//){
	s/es\//e\//;
    }elsif(/s\// && $_ !~ /[us]s\//){
	s/s\//\//;
    }
    $_;
}

;# ---------------------------------------------------------------------------
;#   _increase_frq  --  䤹
;# 
;#   usage : _increase_frq(array_ref, array);
;# ---------------------------------------------------------------------------

sub _increase_frq($$@;){
    my $frq_ref  = shift;
    my $stat_ref = shift;
    my @seg      = @_;
  
    foreach(@$stat_ref){
	last if $_ < 2;
	pop(@seg);
    }
  
    return $this if @seg == 0;
  
    foreach(@seg){
	s/^\s+//;        # ʥڡ
	s/\s+$//;
    
	s/\/[A-Z\$]+$//; # 
    }
  
    my $seg = join(' ', @seg);
  
    $seg =~ s/(\S+)\s(\'s\s)/$1$2/g;
    
    $$frq_ref{$seg}++;
}

}














